Leetcode NO.1 Two Sum

来源:互联网 发布:域名icp备案 编辑:程序博客网 时间:2024/04/27 18:06

题目要求如下:

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

本题思路直观,开始做的时候感觉只有easy的难度,但是后面碰上了点问题,花了点时间,不过仍然算是medium中相对简单的。。

下面是代码:

class Solution {public:    vector<int> twoSum(vector<int> &numbers, int target) {        unordered_map<int, int> num_map;        unordered_map<int, int>::iterator it;        vector<int> index(2);        for (int i = 0; i < numbers.size(); ++i) {        int tmp = target - numbers[i];        it = num_map.find(tmp);        if (it != num_map.end()) {        index[0] = it->second + 1;        index[1] = i + 1;        }        num_map.insert(pair<int, int>(numbers[i], i));    }    return index;    }};
算法:

基本思路就是在插入到hash_map之前,要先检查是否能找到target-该元素,如果能找到,就直接返回这两个index,如果找不到,则正常插入,这种一步一步的插入方式消除了:

如果target=2,有两个元素的value都是1,如果他们都被插入到multi_map中,如果寻找(2-1)可能返回的index还是第一个1的index..

再上传一个更新后的代码,应该会更快才对,因为找到后及时跳出了:

class Solution {public:    vector<int> twoSum(vector<int>& nums, int target) {        vector<int> res(2, -1);        unordered_map<int, int> hashmap;        // key is the number, val is index        for (int i = 0; i < nums.size(); ++i) {            auto got = hashmap.find(target - nums[i]);            if (got != hashmap.end()) {                res[1] = i + 1;                res[0] = got->second + 1;                break;            }            hashmap[nums[i]] = i;        }        return res;    }};



0 0
原创粉丝点击